local m_MyGlobals : table = {}

function GetMyGlobals( MyGlobalsRef : table )
    MyGlobalsRef.MyGlobals = m_MyGlobals;
end
-- Doctrine Events
-- Author: EwokBaconBits
-- DateCreated: 5/11/2017 4:10:00 PM
--------------------------------------------------------------

function addtoDoctrineXP(playerID, doctrineType, xpChange, bBarbarian)
	if ExposedMembers.doctrineXPTableEM ~= nil then
					for i, xpItem in ipairs(ExposedMembers.doctrineXPTableEM) do
									rightGroup = true;
									for j, xpItem in ipairs(xpItem) do
											if j == 1 and (xpItem ~= playerID or playerID == nil) then
												--skip
												rightGroup = false;
											end
											-- Looping through all ArmyUnits
											if j == 2 and rightGroup and doctrineType == 'Infantry' then
												if bBarbarian and xpItem >= 160 then
													xpChange = 0;
												end
												newXP = 0;
												newXP = xpItem + xpChange;
												ExposedMembers.doctrineXPTableEM[i][j]=newXP;										
											end
											if j == 3 and rightGroup and doctrineType == 'Cavalry' then
												if bBarbarian and xpItem >= 160 then
													xpChange = 0;
												end
												newXP = 0;
												newXP = xpItem + xpChange;
												ExposedMembers.doctrineXPTableEM[i][j]=newXP;										
											end
											if j == 4 and rightGroup and doctrineType == 'Recon' then
												if bBarbarian and xpItem >= 160 then
													xpChange = 0;
												end
												newXP = 0;
												newXP = xpItem + xpChange;
												ExposedMembers.doctrineXPTableEM[i][j]=newXP;										
											end
											if j == 5 and rightGroup and doctrineType == 'Ranged' then
												if bBarbarian and xpItem >= 160 then
													xpChange = 0;
												end
												newXP = 0;
												newXP = xpItem + xpChange;
												ExposedMembers.doctrineXPTableEM[i][j]=newXP;										
											end
											if j == 6 and rightGroup and doctrineType == 'Naval' then
												if bBarbarian and xpItem >= 160 then
													xpChange = 0;
												end
												newXP = 0;
												newXP = xpItem + xpChange;
												ExposedMembers.doctrineXPTableEM[i][j]=newXP;										
											end
											if j == 7 and rightGroup and doctrineType == 'Air' then
												if bBarbarian and xpItem >= 160 then
													xpChange = 0;
												end
												newXP = 0;
												newXP = xpItem + xpChange;
												ExposedMembers.doctrineXPTableEM[i][j]=newXP;										
											end
									end								
					end
	end
end




function OnCombat(combatMembers)
		local MyGlobalsRef : table = {};
	LuaEvents.GetMyGlobals(MyGlobalsRef);
	local attacker = combatMembers[CombatResultParameters.ATTACKER]
	local defender = combatMembers[CombatResultParameters.DEFENDER]
	maxBarb = false;
	if attacker ~= nil and defender ~= nil then
		local attackerPlayer = attacker[CombatResultParameters.ID].player;
		local defenderPlayer = defender[CombatResultParameters.ID].player;
		
		if attackerPlayer == 63 or defenderPlayer == 63 then
			maxBarb = true;
		end
	end
	if attacker ~= nil then
			local xpAttackerChange = attacker[CombatResultParameters.EXPERIENCE_CHANGE];
			--local xpDefenderChange = defender[CombatResultParameters.EXPERIENCE_CHANGE];
			local attackerPlayer = attacker[CombatResultParameters.ID].player;
			--local defenderPlayer = defender[CombatResultParameters.ID].player;
			local pUnitAttacker = UnitManager.GetUnit(attackerPlayer, attacker[CombatResultParameters.ID].id);
			if pUnitAttacker ~= nil then
				--local pUnitDefender = UnitManager.GetUnit(defenderPlayer, defender[CombatResultParameters.ID].id);
				local attackerXP = pUnitAttacker:GetExperience():GetExperiencePoints();
				--local defenderXP = pUnitDefender:GetExperience():GetExperiencePoints();
				local pUnitAttackerPromotionClass = GameInfo.Units[pUnitAttacker:GetType()].PromotionClass;
				--local pUnitDefenderPromotionClass = GameInfo.Units[pUnitDefender:GetType()].PromotionClass;
				if pUnitAttackerPromotionClass == "PROMOTION_CLASS_HEAVY_CAVALRY" then
					addtoDoctrineXP(attackerPlayer, 'Cavalry', xpAttackerChange, maxBarb);
				elseif pUnitAttackerPromotionClass == "PROMOTION_CLASS_MELEE" then
					addtoDoctrineXP(attackerPlayer, 'Infantry', xpAttackerChange, maxBarb);
				elseif pUnitAttackerPromotionClass == "PROMOTION_CLASS_RECON" then
					addtoDoctrineXP(attackerPlayer, 'Recon', xpAttackerChange, maxBarb);
				elseif pUnitAttackerPromotionClass == "PROMOTION_CLASS_RANGED" then
					addtoDoctrineXP(attackerPlayer, 'Ranged', xpAttackerChange, maxBarb);
				elseif pUnitAttackerPromotionClass == "PROMOTION_CLASS_SIEGE" then
					addtoDoctrineXP(attackerPlayer, 'Ranged', xpAttackerChange, maxBarb);
				elseif pUnitAttackerPromotionClass == "PROMOTION_CLASS_ANTI_CAVALRY" then
					addtoDoctrineXP(attackerPlayer, 'Infantry', xpAttackerChange, maxBarb);
				elseif pUnitAttackerPromotionClass == "PROMOTION_CLASS_NAVAL_MELEE" then
					addtoDoctrineXP(attackerPlayer, 'Naval', xpAttackerChange, maxBarb);
				elseif pUnitAttackerPromotionClass == "PROMOTION_CLASS_NAVAL_RANGED" then
					addtoDoctrineXP(attackerPlayer, 'Naval', xpAttackerChange, maxBarb);
				elseif pUnitAttackerPromotionClass == "PROMOTION_CLASS_NAVAL_RAIDER" then
					addtoDoctrineXP(attackerPlayer, 'Naval', xpAttackerChange, maxBarb);
				elseif pUnitAttackerPromotionClass == "PROMOTION_CLASS_NAVAL_CARRIER" then
					addtoDoctrineXP(attackerPlayer, 'Naval', xpAttackerChange, maxBarb);
				elseif pUnitAttackerPromotionClass == "PROMOTION_CLASS_AIR_FIGHTER" then
					addtoDoctrineXP(attackerPlayer, 'Air', xpAttackerChange, maxBarb);
				elseif pUnitAttackerPromotionClass == "PROMOTION_CLASS_AIR_BOMBER" then
					addtoDoctrineXP(attackerPlayer, 'Air', xpAttackerChange, maxBarb);
				elseif pUnitAttackerPromotionClass == "PROMOTION_CLASS_LIGHT_CAVALRY" then
					addtoDoctrineXP(attackerPlayer, 'Cavalry', xpAttackerChange, maxBarb);
				end
				--addVeterency(pUnitAttacker);
			end
	end
	if defender ~= nil then
			--local xpAttackerChange = attacker[CombatResultParameters.EXPERIENCE_CHANGE];
			local xpDefenderChange = defender[CombatResultParameters.EXPERIENCE_CHANGE];
			--local attackerPlayer = attacker[CombatResultParameters.ID].player;
			local defenderPlayer = defender[CombatResultParameters.ID].player;
			--local pUnitAttacker = UnitManager.GetUnit(attackerPlayer, attacker[CombatResultParameters.ID].id);
			local pUnitDefender = UnitManager.GetUnit(defenderPlayer, defender[CombatResultParameters.ID].id);
			if pUnitDefender ~= nil then
				--local attackerXP = pUnitAttacker:GetExperience():GetExperiencePoints();
				local defenderXP = pUnitDefender:GetExperience():GetExperiencePoints();
				--local pUnitAttackerPromotionClass = GameInfo.Units[pUnitAttacker:GetType()].PromotionClass;
				local pUnitDefenderPromotionClass = GameInfo.Units[pUnitDefender:GetType()].PromotionClass;
				if pUnitDefenderPromotionClass == "PROMOTION_CLASS_HEAVY_CAVALRY" then
					addtoDoctrineXP(defenderPlayer, 'Cavalry', xpDefenderChange, maxBarb);
				elseif pUnitDefenderPromotionClass == "PROMOTION_CLASS_MELEE" then
					addtoDoctrineXP(defenderPlayer, 'Infantry', xpDefenderChange, maxBarb);
				elseif pUnitDefenderPromotionClass == "PROMOTION_CLASS_RECON" then
					addtoDoctrineXP(defenderPlayer, 'Recon', xpDefenderChange, maxBarb);
				elseif pUnitDefenderPromotionClass == "PROMOTION_CLASS_RANGED" then
					addtoDoctrineXP(defenderPlayer, 'Ranged', xpDefenderChange, maxBarb);
				elseif pUnitDefenderPromotionClass == "PROMOTION_CLASS_SIEGE" then
					addtoDoctrineXP(defenderPlayer, 'Ranged', xpDefenderChange, maxBarb);
				elseif pUnitDefenderPromotionClass == "PROMOTION_CLASS_ANTI_CAVALRY" then
					addtoDoctrineXP(defenderPlayer, 'Infantry', xpDefenderChange, maxBarb);
				elseif pUnitDefenderPromotionClass == "PROMOTION_CLASS_NAVAL_MELEE" then
					addtoDoctrineXP(defenderPlayer, 'Naval', xpDefenderChange, maxBarb);
				elseif pUnitDefenderPromotionClass == "PROMOTION_CLASS_NAVAL_RANGED" then
					addtoDoctrineXP(defenderPlayer, 'Naval', xpDefenderChange, maxBarb);
				elseif pUnitDefenderPromotionClass == "PROMOTION_CLASS_NAVAL_RAIDER" then
					addtoDoctrineXP(defenderPlayer, 'Naval', xpDefenderChange, maxBarb);
				elseif pUnitDefenderPromotionClass == "PROMOTION_CLASS_NAVAL_CARRIER" then
					addtoDoctrineXP(defenderPlayer, 'Naval', xpDefenderChange, maxBarb);
				elseif pUnitDefenderPromotionClass == "PROMOTION_CLASS_AIR_FIGHTER" then
					addtoDoctrineXP(defenderPlayer, 'Air', xpDefenderChange, maxBarb);
				elseif pUnitDefenderPromotionClass == "PROMOTION_CLASS_AIR_BOMBER" then
					addtoDoctrineXP(defenderPlayer, 'Air', xpDefenderChange, maxBarb);
				elseif pUnitDefenderPromotionClass == "PROMOTION_CLASS_LIGHT_CAVALRY" then
					addtoDoctrineXP(defenderPlayer, 'Cavalry', xpDefenderChange, maxBarb);
				end
				--addVeterency(pUnitDefender);
		end
	end
end
Events.Combat.Add( OnCombat );

function addVeterency(pUnit)
	
	local pUnitAttacker = pUnit;
	local attackerXP = pUnitAttacker:GetExperience():GetExperiencePoints();
	local unitType = GameInfo.Units[pUnit:GetType()].UnitType;
	if unitType ~= "UNIT_MISSIONARY" and unitType ~= "UNIT_APOSTLE" and unitType ~= "UNIT_INQUISITOR" and unitType ~= "UNIT_SPY" then
		if attackerXP >= 10 then
			attackerHasPromotion = pUnitAttacker:GetExperience():HasPromotion(GameInfo.UnitPromotions["PROMOTION_REGULARS"].Index);
			if attackerHasPromotion == false then
				pUnitAttacker:GetExperience():SetPromotion(GameInfo.UnitPromotions["PROMOTION_REGULARS"].Index);
			end
		end
	
		if attackerXP >= 25 then
			attackerHasPromotion = pUnitAttacker:GetExperience():HasPromotion(GameInfo.UnitPromotions["PROMOTION_VETERANS"].Index);
			if attackerHasPromotion == false then
				pUnitAttacker:GetExperience():SetPromotion(GameInfo.UnitPromotions["PROMOTION_VETERANS"].Index);
			end
		end
		if attackerXP >= 45 then
			attackerHasPromotion = pUnitAttacker:GetExperience():HasPromotion(GameInfo.UnitPromotions["PROMOTION_SEASONED_VETERANS"].Index);
			if attackerHasPromotion == false then
				pUnitAttacker:GetExperience():SetPromotion(GameInfo.UnitPromotions["PROMOTION_SEASONED_VETERANS"].Index);
			end
		end
		if attackerXP >= 80 then
			attackerHasPromotion = pUnitAttacker:GetExperience():HasPromotion(GameInfo.UnitPromotions["PROMOTION_BATTLE_HARDENED"].Index);
			if attackerHasPromotion == false then
				pUnitAttacker:GetExperience():SetPromotion(GameInfo.UnitPromotions["PROMOTION_BATTLE_HARDENED"].Index);
			end
		end
		if attackerXP >= 120 then
			attackerHasPromotion = pUnitAttacker:GetExperience():HasPromotion(GameInfo.UnitPromotions["PROMOTION_ELITE"].Index);
			if attackerHasPromotion == false then
				pUnitAttacker:GetExperience():SetPromotion(GameInfo.UnitPromotions["PROMOTION_ELITE"].Index);
			end
		end
	end
end



function addPromotionToUnits(playerID)
	local MyGlobalsRef : table = {};
		LuaEvents.GetMyGlobals(MyGlobalsRef);

	local pPlayer = Players[playerID];
	local playerUnits = pPlayer:GetUnits();
	if m_MyGlobals.globalPromotionTable ~= nil then
		for i, promotionItem in ipairs(m_MyGlobals.globalPromotionTable) do
										rightGroup = true;
										for j, promotionItem in ipairs(promotionItem) do
											
												if j == 1 and (promotionItem ~= playerID or playerID == nil) then
													--skip
													rightGroup = false;
												end
												-- Looping through all ArmyUnits
												if j == 2 and rightGroup then
													doctrineType = promotionItem;									
												end
												if j == 3 and rightGroup then
													doctrineClass = promotionItem;
													for i, pUnit in playerUnits:Members() do
															local unitPromotionClass = GameInfo.Units[pUnit:GetType()].PromotionClass;
															local unitCombatStrength = GameInfo.Units[pUnit:GetType()].Combat;
															local unitTypeText = GameInfo.Units[pUnit:GetType()].UnitType;
															local domain = GameInfo.Units[pUnit:GetType()].Domain;
															local applyToCavalry = false;
															local applyToMelee = false;
															local applyToRanged = false;
															local applyToSea = false;
															local applyToRecon = false;
															hasPromotion = pUnit:GetExperience():HasPromotion(GameInfo.UnitPromotions[doctrineType].Index);
															hasPromotionCarrierSpecial = pUnit:GetExperience():HasPromotion(GameInfo.UnitPromotions["PROMOTION_AIRNAVY_CARRIER_BONUS"].Index);
															if hasPromotion == false then
																if doctrineClass == "PROMOTION_CLASS_LIGHT_CAVALRY" and (unitPromotionClass == doctrineClass or unitPromotionClass == "PROMOTION_CLASS_HEAVY_CAVALRY")  then
																	applyToCavalry = true;
																end
																if doctrineClass == "PROMOTION_CLASS_MELEE" and (unitPromotionClass == doctrineClass or unitPromotionClass == "PROMOTION_CLASS_ANTI_CAVALRY")  then
																	applyToMelee = true;
																end
																if doctrineClass == "PROMOTION_CLASS_SIEGE" and (unitPromotionClass == doctrineClass or unitPromotionClass == "PROMOTION_CLASS_RANGED")  then
																	applyToRanged = true;
																end
																if doctrineClass == "PROMOTION_CLASS_NAVAL_MELEE" and (unitPromotionClass == doctrineClass or unitPromotionClass == "PROMOTION_CLASS_NAVAL_RANGED" or unitPromotionClass == "PROMOTION_CLASS_NAVAL_CARRIER" or unitPromotionClass == "PROMOTION_CLASS_NAVAL_RAIDER")  then
																	applyToSea = true;
																end
																if doctrineClass == "PROMOTION_CLASS_RECON" and unitPromotionClass == doctrineClass then
																	applyToRecon = true;
																end
																if doctrineType == "PROMOTION_IMD_A_DESIGNATED_SIGNALS" and unitCombatStrength > 0 then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_IMD_A_DEFENSIVE_MARCH" and unitCombatStrength > 0 and (unitPromotionClass == "PROMOTION_CLASS_RANGED" or unitPromotionClass == doctrineClass or unitPromotionClass == "PROMOTION_CLASS_ANTI_CAVALRY") then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_IMD_A_MARTIAL_DISCIPLINE" and unitCombatStrength > 0 then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_IMD_A_PHALANX" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_ANTI_CAVALRY" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_IMD_A_ECHELON" and unitCombatStrength > 0 then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_IMD_B_INFANTRY_STRUCTURE" and domain == "DOMAIN_LAND" and unitCombatStrength > 0 then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_IMD_B_CHAIN_OF_COMMAND" and domain == "DOMAIN_LAND" and unitCombatStrength > 0 then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_IMD_C_SPECIAL_FORCES" and unitCombatStrength > 0 then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_IMD_C_ELASTIC_DEFENSE" and unitCombatStrength > 0 and (unitPromotionClass == "PROMOTION_CLASS_RANGED" or unitPromotionClass == doctrineClass or unitPromotionClass == "PROMOTION_CLASS_ANTI_CAVALRY") then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_IMD_C_SPECIAL_FORCES" and unitCombatStrength > 0 then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_CMD_A_CONDENSED_CHARGES" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_HEAVY_CAVALRY" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_CMD_A_CAVALRY_SCOUTING" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_LIGHT_CAVALRY" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_CMD_A_DECEPTION_MANEUVERS" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_LIGHT_CAVALRY" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_CMD_A_CHARGE_CYCLES" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_HEAVY_CAVALRY" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_CMD_B_LOGISTICAL_RAIDING" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_LIGHT_CAVALRY" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_A_RANGE_FINDING" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_SIEGE" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_A_DEFENSIVE_EMPLACEMENTS" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_SIEGE" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_A_VOLLEY" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_RANGED" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_A_INFANTRY_INTEGRATION" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_RANGED" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_A_FOCUS_ATTACK" and unitCombatStrength > 0 and (unitPromotionClass == "PROMOTION_CLASS_RANGED" or unitPromotionClass == "PROMOTION_CLASS_SIEGE" or unitPromotionClass == "PROMOTION_CLASS_NAVAL_RANGED") then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_A_INCENDIARIES" and unitCombatStrength > 0 and (unitPromotionClass == "PROMOTION_CLASS_RANGED" or unitPromotionClass == "PROMOTION_CLASS_SIEGE") then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_B_STRATEGIC_PLACEMENT" and unitCombatStrength > 0 and (unitPromotionClass == "PROMOTION_CLASS_RANGED" or unitPromotionClass == "PROMOTION_CLASS_SIEGE") then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_B_SUPPRESSION" and unitCombatStrength > 0 and (unitPromotionClass == "PROMOTION_CLASS_RANGED" or unitPromotionClass == "PROMOTION_CLASS_SIEGE") then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_C_FORWARD_OBSERVERS" and unitCombatStrength > 0 and (unitPromotionClass == "PROMOTION_CLASS_SIEGE" or unitPromotionClass == "PROMOTION_CLASS_NAVAL_RANGED") then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_C_OVERWHELMING_FIREPOWER" and unitCombatStrength > 0 and (unitPromotionClass == "PROMOTION_CLASS_RANGED" or unitPromotionClass == "PROMOTION_CLASS_SIEGE" or unitPromotionClass == "PROMOTION_CLASS_NAVAL_RANGED") then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_A_SKIRMISHING" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_RANGED" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_A_ATTACK_ROTATION" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_RANGED" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_B_SUPPLY_CHAINS" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_RANGED" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_RMD_B_BATTERIES" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_SIEGE" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_AMD_A_DIVE_BOMBING" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_AIR_FIGHTER" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_AMD_A_GROUND_INTEGRATION" and unitCombatStrength > 0 and (unitPromotionClass == "PROMOTION_CLASS_AIR_FIGHTER" or unitPromotionClass == "PROMOTION_CLASS_AIR_BOMBER") then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_AMD_A_FORMATION_FLYING" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_AIR_FIGHTER" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_AMD_A_FIGHTER_SWEEPS" and unitCombatStrength > 0 and (unitPromotionClass == "PROMOTION_CLASS_AIR_FIGHTER" or unitPromotionClass == "PROMOTION_CLASS_AIR_BOMBER") then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_AMD_A_MASSED_RAIDS" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_AIR_BOMBER" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_AMD_B_AIR_NAVY_BATTLE" and unitCombatStrength > 0 and (unitPromotionClass == "PROMOTION_CLASS_AIR_FIGHTER" or unitPromotionClass == "PROMOTION_CLASS_AIR_BOMBER") then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_AMD_B_AIR_NAVY_BATTLE" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_NAVAL_CARRIER" and  hasPromotionCarrierSpecial == false then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions["PROMOTION_AIRNAVY_CARRIER_BONUS"].Index);
																elseif doctrineType == "PROMOTION_AMD_B_BAITING_MANEUVERS" and unitCombatStrength > 0 and (unitPromotionClass == "PROMOTION_CLASS_AIR_FIGHTER" or unitPromotionClass == "PROMOTION_CLASS_AIR_BOMBER") then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_AMD_B_CAROUSEL_BOMBING" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_AIR_BOMBER" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_SMD_A_NIGHT_OPERATIONS" and unitCombatStrength > 0 and unitPromotionClass ~= "PROMOTION_CLASS_RANGED" and unitPromotionClass ~= "PROMOTION_CLASS_SIEGE" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_NMD_A_CONCURRENT_FIRE" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_NAVAL_RANGED" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_NMD_A_RAMMING_TECHNIQUE" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_NAVAL_MELEE" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_NMD_A_DEDICATED_MARINES" and unitCombatStrength > 0 and unitCombatStrength > 0 then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_NMD_B_LINE_OF_BATTLE" and unitCombatStrength > 0 and unitPromotionClass == "PROMOTION_CLASS_NAVAL_RANGED" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif doctrineType == "PROMOTION_NMD_C_CAPITAL_SHIP_SUPREMACY" and unitCombatStrength > 0 and (unitPromotionClass == "PROMOTION_CLASS_NAVAL_MELEE" or unitPromotionClass == "PROMOTION_CLASS_NAVAL_RAIDER") then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif applyToCavalry and doctrineType ~= "PROMOTION_CMD_A_CONDENSED_CHARGES" and unitCombatStrength > 0 and doctrineType ~= "PROMOTION_CMD_A_CAVALRY_SCOUTING" and doctrineType ~= "PROMOTION_CMD_A_DECEPTION_MANEUVERS" and doctrineType ~= "PROMOTION_CMD_A_CHARGE_CYCLES" and doctrineType ~= "PROMOTION_CMD_B_LOGISTICAL_RAIDING" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif applyToMelee and doctrineType ~= "PROMOTION_IMD_A_PHALANX" and unitCombatStrength > 0 then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif applyToRanged and doctrineType ~= "PROMOTION_RMD_A_RANGE_FINDING" and unitCombatStrength > 0 and doctrineType ~= "PROMOTION_RMD_A_DEFENSIVE_EMPLACEMENTS" and doctrineType ~= "PROMOTION_RMD_A_VOLLEY" and doctrineType ~= "PROMOTION_RMD_A_INFANTRY_INTEGRATION" and doctrineType ~= "PROMOTION_RMD_A_SKIRMISHING" and doctrineType ~= "PROMOTION_RMD_A_ATTACK_ROTATION" and doctrineType ~= "PROMOTION_RMD_B_SUPPLY_CHAINS" and doctrineType ~= "PROMOTION_RMD_B_BATTERIES" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif applyToSea and doctrineType ~= "PROMOTION_NMD_A_CONCURRENT_FIRE" and unitCombatStrength > 0 and doctrineType ~= "PROMOTION_NMD_A_RAMMING_TECHNIQUE" and doctrineType ~= "PROMOTION_NMD_B_LINE_OF_BATTLE" and doctrineType ~= "PROMOTION_NMD_C_CAPITAL_SHIP_SUPREMACY" then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																elseif applyToRecon then
																	pUnit:GetExperience():SetPromotion(GameInfo.UnitPromotions[doctrineType].Index);
																end
															end
													end
												end
										end								
			end
		end
	

end

function OnUnitAddedToMap(player, unit, x, y)
	addPromotionToUnits(player);
	local pUnit = UnitManager.GetUnit(player, unit);
	--addVeterency(pUnit);
end
function OnPlayerTurnDeactivated( ePlayer:number )
	addPromotionToUnits(ePlayer);	
end
function OnGoodyHutReward(playerID, unitID, plotID) -- guesses on what these args are
	local pPlayer = Players[playerID];
	local pUnit = pPlayer:GetUnits():FindID(unitID);
	promotionClass = GameInfo.Units[pUnit:GetType()].PromotionClass
	if promotionClass == "PROMOTION_CLASS_RECON" then
		addtoDoctrineXP(playerID, 'Recon', 6);
	end
end
Events.UnitAddedToMap.Add(			OnUnitAddedToMap );
Events.PlayerTurnDeactivated.Add( OnPlayerTurnDeactivated );
Events.GoodyHutReward.Add(			OnGoodyHutReward );
LuaEvents.GetMyGlobals.Add(GetMyGlobals);

function Initialize()
	doctrineLevelTable = GameConfiguration.GetValue ("doctrineLevelTable");
	doctrineXPTable = GameConfiguration.GetValue ("doctrineXPTable");
	doctrinePromotionTable = GameConfiguration.GetValue ("doctrinePromotionTable");
	ExposedMembers.doctrineLevelTableEM = {};
	ExposedMembers.doctrineXPTableEM = {};
	ExposedMembers.promotionTableEM = {};
	ExposedMembers.infantryXPTotal = 0;
	ExposedMembers.cavalryXPTotal = 0;
	ExposedMembers.reconXPTotal = 0;
	ExposedMembers.rangedXPTotal = 0;
	ExposedMembers.navalXPTotal = 0;
	ExposedMembers.airXPTotal = 0;
	if doctrineLevelTable == nil then
			for i, pPlayer in ipairs(PlayerManager.GetAliveMajors()) do			
				local iPlayer = pPlayer:GetID();
				newPlayerPromotionLevelCount = {};
				numInfantryLevels1 = 0;
				numInfantryLevels2 = 0;
				numInfantryLevels3 = 0;
				numCavalryLevels1 = 0;
				numCavalryLevels2 = 0;
				numCavalryLevels3 = 0;
				numReconLevels1 = 0;
				numReconLevels2 = 0;
				numReconLevels3 = 0;
				numRangedLevels1 = 0;
				numRangedLevels2 = 0;
				numRangedLevels3 = 0;
				numNavalLevels1 = 0;
				numNavalLevels2 = 0;
				numNavalLevels3 = 0;
				numAirLevels1 = 0;
				numAirLevels2 = 0;
				numAirLevels3 = 0;
				table.insert(newPlayerPromotionLevelCount, 1, iPlayer);
				table.insert(newPlayerPromotionLevelCount, 2, numInfantryLevels1);
				table.insert(newPlayerPromotionLevelCount, 3, numInfantryLevels2);
				table.insert(newPlayerPromotionLevelCount, 4, numInfantryLevels3);
				table.insert(newPlayerPromotionLevelCount, 5, numCavalryLevels1);
				table.insert(newPlayerPromotionLevelCount, 6, numCavalryLevels2);
				table.insert(newPlayerPromotionLevelCount, 7, numCavalryLevels3);
				table.insert(newPlayerPromotionLevelCount, 8, numReconLevels1);
				table.insert(newPlayerPromotionLevelCount, 9, numReconLevels2);
				table.insert(newPlayerPromotionLevelCount, 10, numReconLevels3);
				table.insert(newPlayerPromotionLevelCount, 11, numRangedLevels1);
				table.insert(newPlayerPromotionLevelCount, 12, numRangedLevels2);
				table.insert(newPlayerPromotionLevelCount, 13, numRangedLevels3);
				table.insert(newPlayerPromotionLevelCount, 14, numNavalLevels1);
				table.insert(newPlayerPromotionLevelCount, 15, numNavalLevels2);
				table.insert(newPlayerPromotionLevelCount, 16, numNavalLevels3);
				table.insert(newPlayerPromotionLevelCount, 17, numAirLevels1);
				table.insert(newPlayerPromotionLevelCount, 18, numAirLevels2);
				table.insert(newPlayerPromotionLevelCount, 19, numAirLevels3);
				table.insert(ExposedMembers.doctrineLevelTableEM, 1, newPlayerPromotionLevelCount);
				-- Set XP Totals too
				
			end
	else
		
		doctrineLevelTable = GameConfiguration.GetValue ("doctrineLevelTable");
		print(doctrineLevelTable);
		if doctrineLevelTable ~= nil then
			
			for i in string.gmatch(doctrineLevelTable, "[^!]*") do
			num = 2;
			   if i ~= "" and i ~= "!" then
					print("i = " .. i);
					for j in string.gmatch(i, "[^@]*") do
						if j ~= "" then
							j = tonumber(j);
							if j ~= nil then
								print("j = " .. j);
								newPlayerPromotionLevelCount = {j};
							end
						end
					end
					for k in string.gmatch(i, "[^#]*") do
						if k ~= "" then
							k = tonumber(k);
							if k ~= nil then
								print("k = " .. k);
								table.insert(newPlayerPromotionLevelCount, num, k);
								num = num + 1;
							end
						end
					end
					table.insert(ExposedMembers.doctrineLevelTableEM, 1, newPlayerPromotionLevelCount);
				end
				
			end
		end
	end
	if doctrineXPTable == nil then
		for i, pPlayer in ipairs(PlayerManager.GetAliveMajors()) do		
				local iPlayer = pPlayer:GetID();
				newPlayerXPCount = {};
				table.insert(newPlayerXPCount, 1, iPlayer);
				infantryXP = 0;
				cavalryXP = 0;
				reconXP = 0;
				rangedXP = 0;
				navalXP = 0;
				airXP = 0;
				table.insert(newPlayerXPCount, 2, infantryXP);
				table.insert(newPlayerXPCount, 3, cavalryXP);
				table.insert(newPlayerXPCount, 4, reconXP);
				table.insert(newPlayerXPCount, 5, rangedXP);
				table.insert(newPlayerXPCount, 6, navalXP);
				table.insert(newPlayerXPCount, 7, airXP);
				table.insert(ExposedMembers.doctrineXPTableEM, 1, newPlayerXPCount);
		end
	else
		if doctrineXPTable ~= nil then
			print(doctrineXPTable);
			
			for i in string.gmatch(doctrineXPTable, "[^!]*") do
			num = 2;
			   if i ~= "" and i ~= "!" then
					--print("i = " .. i);
					for j in string.gmatch(i, "[^@]*") do
						if j ~= "" then
							j = tonumber(j);
							if j ~= nil then
								--print("j = " .. j);
								newPlayerPromotionXPCount = {j};
							end
						end
					end
					for k in string.gmatch(i, "[^#]*") do
						if k ~= "" then
							k = tonumber(k);
							--if(k:match("^[a-zA-Z0-9_]*$")) then
							if k ~= nil then
								--print("k = " .. k);
								table.insert(newPlayerPromotionXPCount, num, k);
								num = num + 1;
							end
							--end
						end
					end
					table.insert(ExposedMembers.doctrineXPTableEM, 1, newPlayerPromotionXPCount);
				end
				
			end
		end
	end
	if doctrinePromotionTable == nil then
		print("1st Session skip");
	else
		if doctrinePromotionTable ~= nil then
			print(doctrinePromotionTable);
			
			for i in string.gmatch(doctrinePromotionTable, "[^!]*") do
			   if i ~= "" and i ~= "!" then
					print("i = " .. i);
					for j in string.gmatch(i, "[^@]*") do
						if j ~= "" then
							j = tonumber(j);
							if j ~= nil then
								print("j = " .. j);
								newPlayerPromotionList = {j};
							end
						end
					end
					for k in string.gmatch(i, "[^#]*") do
							if(k:match("^[a-zA-Z0-9_]*$")) then
								if k ~= "" then
									print("k = " .. k);
									table.insert(newPlayerPromotionList, 2, k);
								end
							end
					end
					for l in string.gmatch(i, "[^$]*") do
						if(l:match("^[a-zA-Z0-9_]*$")) then
							if l ~= "" then
								print("l = " .. l);
								table.insert(newPlayerPromotionList, 3, l);
							end
						end
					end

					table.insert(ExposedMembers.promotionTableEM, 1, newPlayerPromotionList);
				end
				
			end
		end
	end
end
Initialize();
